var FIRST_RUN_HAPPENED = "first_run_256";

var controllers_module = angular.module('experticity.controllers',
  ['ionic', 'experticity.eventControllers', 'experticity.quizControllers',
   'experticity.userControllers', 'experticity.infoControllers']);


controllers_module.controller('AppCtrl',
  function($scope, $state, $ionicHistory, $timeout, $ionicPlatform, $ionicAnalytics, UserService, QuizService, resolvedUser) {

  $ionicPlatform.ready(function () {
    // We need to time outs here to let the dom load, and ensure the
    // mask is loaded in the background.
    $timeout(function() {
      $scope.$broadcast('show-mask');
      $timeout(function () {
        navigator.splashscreen.hide();
      }, 100);
    }, 500);

    // Try to refresh the users token.
    // If not, send them to a login screen.
    if (resolvedUser.profile === undefined || (resolvedUser.profile || {}).id === null) {
        $ionicPlatform.ready(function() {
          if(typeof window.analytics !== 'undefined') { window.analytics.trackView("About - Lost Token");
          }
        });
        $ionicAnalytics.track('About', {
          item_id: 'abft',
          item_name: 'Lost Token',
        });

        no_user();
    }
  });


  QuizService.sync();


  function no_user() {
    console.log('About - First Time');

    $ionicPlatform.ready(function() {
      if(typeof window.analytics !== 'undefined') { window.analytics.trackView("About - First Time");
      }
    });
    $ionicAnalytics.track('About', {
      item_id: 'abft',
      item_name: 'First Time'
    });

    $state.go('app.about');
  }
});
