var events_controllers_module = angular.module('experticity.eventControllers', []);

events_controllers_module.controller('EventsCtrl',
  function($scope, $ionicHistory, $ionicPlatform, $ionicAnalytics, QuizService) {

  $ionicPlatform.ready(function() {
    if(typeof window.analytics !== 'undefined') { window.analytics.trackView("Events List");
    }
  });
  $ionicAnalytics.track('Events', {
    item_id: 'evli',
    item_name: 'List',
  });

  var getEvents = function () {
    QuizService.getEvents().then(
      function (events) {
        $scope.has_error = false;

        $scope.events = events.data;
      }, function (error) {
        if ($scope.events.length === 0) {
          $scope.has_error = true;
        }
      }
    ).finally(function () {
      $scope.$broadcast('scroll.refreshComplete');
    });
  };

  $scope.events = [];
  // Use this call back, so even though it's cached.
  // it will still get refreshed when the view is resumed.
  $scope.$on('$ionicView.enter', function () {
    // If we don't have any events. Sync with the server.
    if ($scope.events.length === 0) {
      $scope.$broadcast('show-spinner');
      QuizService.sync().then(function () {
        getEvents();
      }, function () {
        getEvents();
      }).finally(function () {
        $scope.$broadcast('hide-spinner');
      });
    } else {
      getEvents();
    }
  });

  $scope.doRefresh = function () {
    $ionicPlatform.ready(function() {
      if(typeof window.analytics !== 'undefined') { window.analytics.trackView("Events List - Refresh");
      }
    });
    $ionicAnalytics.track('Events', {
      item_id: 'abftr',
      item_name: 'List Refresh',
    });

    getEvents();
    QuizService.sync();
  };
});

/*
  SINGLE EVENT CONTROLLER
 */
events_controllers_module.controller('EventQuizzesCtrl',
  function($scope, $state, $stateParams, $ionicHistory, $ionicPlatform, $ionicAnalytics, QuizService) {
  $ionicPlatform.ready(function() {
    if(typeof window.analytics !== 'undefined') { window.analytics.trackView("Events Quizzes List");
    }
  });
  $ionicAnalytics.track('Events Quizzes List', {
    item_id: 'evql',
    item_name: 'Open',
  });

  $scope.eventId = $stateParams.eventId;

  QuizService.getEvent($scope.eventId).then(function (event) {
    $scope.event = event;
  });
});
