var info_controllers_module = angular.module('experticity.infoControllers', []);

info_controllers_module.controller('MoreInfoCtrl',
    function ($scope, $ionicModal, PagesService, UserService, QuizService, $ionicPlatform, $ionicScrollDelegate) {
        $ionicPlatform.ready(function () {
            if (typeof analytics !== 'undefined') {
                window.analytics.trackView("More Info");
            }
        });
        // Get the latest terms and rules.
        PagesService.getPages().then(
            function (success) {
                $scope.pages = success;
            }
        );

        PagesService.getAppText().then(
          function (success) {
            $scope.promotive_url = success.about_promotive_url;
          }
        );

        $scope.openPromotive = function () {
          cordova.InAppBrowser.open($scope.promotive_url, '_system', 'location=yes');
        };
    });

info_controllers_module.controller('MoreInfoDetailCtrl', function ($scope, $stateParams, $state, $ionicPlatform, PagesService) {
  $ionicPlatform.ready(function() {
    if(typeof window.analytics !== 'undefined') { window.analytics.trackView("More Info Detail");
    }
  });

  PagesService.getPages().then(
      function (success) {
        for (var detail in success) {
            if (success[detail].slug == $stateParams.pageSlug) {
                $scope.detail_title = success[detail].title;
                $scope.detail_page_text = success[detail].page_text;
            }
        }
      },
      function (error) {
      }
  );
});

info_controllers_module.controller('AboutTheAppCtrl', function ($scope, $ionicHistory, PagesService) {
    // TODO: Here, do some sort of signal, to wait until the app has finished downloading
    // the terms and such. Displaying the mask until then.
    PagesService.getAppText().then(
        function (app_text) {
          $scope.welcome_screen_tag_line = app_text.welcome_screen_tag_line;
          $scope.welcome_screen_text = app_text.welcome_screen_text;
        }
    );
});
